#include "TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>  
#include <fstream>
#include "TMDlib_UnintegratedGluonKS.h"
#include "TMDlib_InterpolationKS.h"
using namespace std;

/* Common Block Declarations */

extern int iset, irep, imode ;
extern string pdfpath;
extern bool first;
UnintegratedGluon *_updf;

string filename ;

 void TMDlib::ksPDF(double x, double kt, double p, double& uval, double& dval, double& sea, double& charm, double& bottom, double& glu)
{    

 //   UnintegratedGluon updf  ;
 //       UnintegratedGluon updf = UnintegratedGluon() ;
   gsl_interp_type int_type =  *gsl_interp_cspline;
//    cout << " ksPDF " << first << endl;
    
    if (first) { 
//       UnintegratedGluon updf  ;
       if( iset < 0 ) 
        { cout << "  TMDlib:ksuPDF set not foud. iset = " << iset << endl;
         return ; }
        else if ( iset == 400001 ) { 
            filename=pdfpath+"KSlinear.dat";} 
        else if ( iset == 400002 ) { 
            filename=pdfpath+"KSnonlinear.dat";} 
   	 cout <<  "ksuPDF: read grid from " << filename << endl;
       _updf = new UnintegratedGluon(filename,int_type);
       first = false ;
       }
       
     
     double logx = log(x);       
     glu = 1 ;
       /// Created updf object
       glu = _updf->xg(logx,log(kt*kt)) ;
//     cout << " TMDlib ks gluon = " << glu << " " << logx << " " << kt << endl;
     uval = 0 ;
     dval = 0 ; 

     return ;
}
